/*
Border Ring think script
	Based on the think script for Cheese
	by Steel Titanium

Handles Border Ring following Espibee and changing to Espibee's states
*/

local clientplayer
local pcam

//Freeslot the required stuff
freeslot(
	"SPR_EPBB",
	"SPR_PSPB",
	"S_RBORDERIDLE1",
	"S_RBORDERIDLE2",
	"S_RBORDERACTIVE1",
	"S_RBORDERACTIVE2",
	"S_RBORDERACTIVE3",
	"S_RBORDERACTIVE4",
	"MT_RBORDER",
	"MT_RBORDER2"
)

mobjinfo[MT_RBORDER] = {
	doomednum = -1,
	spawnstate = S_RBORDERIDLE1,
	spawnhealth = 1,
	painchance = 200,
	speed = 3,
	radius = 64*FRACUNIT,
	height = 64*FRACUNIT,
	dispoffset = 1,
	mass = 100,
	damage = 0,
	reactiontime = 32,
	activesound = sfx_None,
	flags = MF_NOGRAVITY|MF_FLOAT|MF_SCENERY|MF_NOCLIPHEIGHT|MF_DONTENCOREMAP,
	raisestate = S_NULL
}

states[S_RBORDERIDLE1] = {
	sprite = SPR_EPBB,
	frame = FF_FULLBRIGHT|TR_TRANS20|C,
	tics = 1,
	action = A_CapeChase,
	var1 = FRACUNIT*16,
	var2 = 0,
	nextstate = S_RBORDERIDLE1
}

states[S_RBORDERACTIVE1] = {
	sprite = SPR_EPBB,
	frame = FF_FULLBRIGHT|C,
	tics = 1,
	action = A_CapeChase,
	var1 = FRACUNIT*16,
	var2 = 0,
	nextstate = S_RBORDERACTIVE2
}

states[S_RBORDERACTIVE2] = {
	sprite = SPR_EPBB,
	frame = FF_FULLBRIGHT|D,
	tics = 1,
	action = A_CapeChase,
	var1 = FRACUNIT*16,
	var2 = 0,
	nextstate = S_RBORDERACTIVE1
}

mobjinfo[MT_RBORDER2] = {
	doomednum = -1,
	spawnstate = S_RBORDERIDLE2,
	spawnhealth = 1,
	painchance = 200,
	speed = 3,
	radius = 64*FRACUNIT,
	height = 64*FRACUNIT,
	dispoffset = -1,
	mass = 100,
	damage = 0,
	reactiontime = 32,
	activesound = sfx_None,
	flags = MF_NOGRAVITY|MF_FLOAT|MF_SCENERY|MF_NOCLIPHEIGHT|MF_DONTENCOREMAP,
	raisestate = S_NULL
}

states[S_RBORDERIDLE2] = {
	sprite = SPR_EPBB,
	frame = FF_FULLBRIGHT|TR_TRANS10|E,
	tics = 1,
	action = A_CapeChase,
	var1 = FRACUNIT*16,
	var2 = 0,
	nextstate = S_RBORDERIDLE2
}

states[S_RBORDERACTIVE3] = {
	sprite = SPR_EPBB,
	frame = FF_FULLBRIGHT|E,
	tics = 1,
	action = A_CapeChase,
	var1 = FRACUNIT*16,
	var2 = 0,
	nextstate = S_RBORDERACTIVE4
}

states[S_RBORDERACTIVE4] = {
	sprite = SPR_EPBB,
	frame = FF_FULLBRIGHT|F,
	tics = 1,
	action = A_CapeChase,
	var1 = FRACUNIT*16,
	var2 = 0,
	nextstate = S_RBORDERACTIVE3
}

addHook("MobjThinker", function(mo)
	if mo and mo.skin == "espibee" and mo.player //Skin check
		local player = mo.player
		if not player.mo.rborder //Spawn and bind Ring Border
			player.mo.rborder = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_RBORDER)
			player.mo.rborder.angle = player.mo.angle
			player.mo.rborder.flags2 = player.mo.flags2
			player.mo.rborder.scale = player.mo.scale
			player.mo.rborder.target = player.mo
		end
		if not player.mo.rborder2 //Spawn and bind Ring Border 2, the back layer
			player.mo.rborder2 = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_RBORDER2)
			player.mo.rborder2.angle = player.mo.angle
			player.mo.rborder2.flags2 = player.mo.flags2
			player.mo.rborder2.scale = player.mo.scale
			player.mo.rborder2.target = player.mo
		end
	elseif mo and mo.skin ~= "espibee" and mo.rborder and mo.rborder.valid then // Not using Espibee but still has the Border Ring with them.
		P_RemoveMobj(mo.rborder)
		P_RemoveMobj(mo.rborder2)
		mo.rborder = nil
	end
end, MT_PLAYER)

addHook("MobjThinker", function(mo)
	//Thinker for Border Ring
	if mo and mo.valid then
		if mo.target and mo.target.valid and mo.target.player and mo.target.player.valid then
			local tg = mo.target
			local totz

			if (mo.eflags & MFE_VERTICALFLIP)
				totz = (tg.z) - (tg.height)
			else
				totz = (tg.z) + (tg.height)
			end

			mo.scale = tg.scale
			mo.angle = tg.angle
			mo.color = tg.color
			mo.colorized = tg.colorized
			mo.eflags = tg.eflags
			mo.flags2 = tg.flags2

			if tg.health > 0 and tg.player.kartstuff[k_spinouttimer] == 0 then
				if tg.player.speed > K_GetKartSpeed(tg.player) then // If player is boosting

					if not (mo.state == S_RBORDERACTIVE1)
					and not (mo.state == S_RBORDERACTIVE2)
						mo.state = S_RBORDERACTIVE1
					end

				else //If player is not boosting
				
					if not (mo.state == S_RBORDERIDLE1)
						mo.state = S_RBORDERIDLE1
					end
					
				end
			end
		end
	end


	if mo and (not mo.target or not mo.target.valid) or (not mo.target.player or not mo.target.valid) then
		P_RemoveMobj(mo)
    end

end, MT_RBORDER)

addHook("MobjThinker", function(mo)
	//Thinker for Border Ring 2, THE BACK DOWN
	if mo and mo.valid then
		if mo.target and mo.target.valid and mo.target.player and mo.target.player.valid then
			local tg = mo.target
			local totz

			if (mo.eflags & MFE_VERTICALFLIP)
				totz = (tg.z) - (tg.height)
			else
				totz = (tg.z) + (tg.height)
			end

			mo.scale = tg.scale
			mo.angle = tg.angle
			mo.color = tg.color
			mo.colorized = tg.colorized
			mo.eflags = tg.eflags
			mo.flags2 = tg.flags2

			if tg.health > 0 and tg.player.kartstuff[k_spinouttimer] == 0 then
				if tg.player.speed > K_GetKartSpeed(tg.player) then // If player is boosting

					if not (mo.state == S_RBORDERACTIVE3)
					and not (mo.state == S_RBORDERACTIVE4)
						mo.state = S_RBORDERACTIVE3
					end

				else //If player is not boosting
				
					if not (mo.state == S_RBORDERIDLE2)
						mo.state = S_RBORDERIDLE2
					end
					
				end
			end
		end
	end


	if mo and (not mo.target or not mo.target.valid) or (not mo.target.player or not mo.target.valid) then
		P_RemoveMobj(mo)
    end

end, MT_RBORDER2)


local function mocamhack(v, player, cam)
    if not player.mo
        return
    end

	clientplayer = player
	pcam = cam
end

hud.add(mocamhack, player, cam)